Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 102812)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 102813)
@@ -247,5 +247,5 @@
 }
 
-void UIVirtualBoxManagerWidget::switchToGlobalTool(UIToolType enmType)
+void UIVirtualBoxManagerWidget::switchGlobalToolTo(UIToolType enmType)
 {
     /* Open corresponding tool: */
@@ -259,5 +259,5 @@
 }
 
-void UIVirtualBoxManagerWidget::switchToMachineTool(UIToolType enmType)
+void UIVirtualBoxManagerWidget::switchMachineToolTo(UIToolType enmType)
 {
     /* Open corresponding tool: */
@@ -517,7 +517,7 @@
         if (fCurrentItemIsOk)
         {
-            /* If Error-pane is chosen currently => open tool currently chosen in Tools-pane: */
+            /* If Error-pane is chosen currently => switch to tool currently chosen in Tools-menu: */
             if (m_pPaneToolsMachine->currentTool() == UIToolType_Error)
-                sltHandleMachineToolsPaneIndexChange();
+                switchMachineToolTo(m_pMenuToolsMachine->toolsType());
 
             /* If we still have same item selected: */
@@ -572,14 +572,4 @@
     // smaller size often being ignored until it is actually shown.
     pMenu->resize(ourGeo.size());
-}
-
-void UIVirtualBoxManagerWidget::sltHandleGlobalToolsPaneIndexChange()
-{
-    switchToGlobalTool(m_pMenuToolsGlobal->toolsType());
-}
-
-void UIVirtualBoxManagerWidget::sltHandleMachineToolsPaneIndexChange()
-{
-    switchToMachineTool(m_pMenuToolsMachine->toolsType());
 }
 
@@ -820,7 +810,7 @@
     /* Tools-pane connections: */
     connect(m_pMenuToolsGlobal, &UITools::sigSelectionChanged,
-            this, &UIVirtualBoxManagerWidget::sltHandleGlobalToolsPaneIndexChange);
+            this, &UIVirtualBoxManagerWidget::sltHandleGlobalToolsMenuIndexChange);
     connect(m_pMenuToolsMachine, &UITools::sigSelectionChanged,
-            this, &UIVirtualBoxManagerWidget::sltHandleMachineToolsPaneIndexChange);
+            this, &UIVirtualBoxManagerWidget::sltHandleMachineToolsMenuIndexChange);
 }
 
@@ -846,7 +836,7 @@
     }
 
-    /* Open tools last chosen in Tools-pane: */
-    switchToGlobalTool(m_pMenuToolsGlobal->toolsType());
-    switchToMachineTool(m_pMenuToolsMachine->toolsType());
+    /* Open tools last chosen in Tools-menu: */
+    switchGlobalToolTo(m_pMenuToolsGlobal->toolsType());
+    switchMachineToolTo(m_pMenuToolsMachine->toolsType());
 }
 
@@ -1074,7 +1064,7 @@
     /* Tools-pane connections: */
     disconnect(m_pMenuToolsGlobal, &UITools::sigSelectionChanged,
-               this, &UIVirtualBoxManagerWidget::sltHandleGlobalToolsPaneIndexChange);
+               this, &UIVirtualBoxManagerWidget::sltHandleGlobalToolsMenuIndexChange);
     disconnect(m_pMenuToolsMachine, &UITools::sigSelectionChanged,
-               this, &UIVirtualBoxManagerWidget::sltHandleMachineToolsPaneIndexChange);
+               this, &UIVirtualBoxManagerWidget::sltHandleMachineToolsMenuIndexChange);
 }
 
@@ -1150,7 +1140,7 @@
     if (fCurrentItemIsOk)
     {
-        /* If Error-pane is chosen currently => open tool currently chosen in Tools-pane: */
+        /* If Error-pane is chosen currently => switch to tool currently chosen in Tools-menu: */
         if (m_pPaneToolsMachine->currentTool() == UIToolType_Error)
-            sltHandleMachineToolsPaneIndexChange();
+            switchMachineToolTo(m_pMenuToolsMachine->toolsType());
 
         /* Propagate current items to the Tools pane: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 102812)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 102813)
@@ -222,8 +222,8 @@
         /** Returns whether Machine tool of passed @a enmType is opened. */
         bool isMachineToolOpened(UIToolType enmType) const;
-        /** Switches to Global tool of passed @a enmType. */
-        void switchToGlobalTool(UIToolType enmType);
-        /** Switches to Machine tool of passed @a enmType. */
-        void switchToMachineTool(UIToolType enmType);
+        /** Switches Global tool to passed @a enmType. */
+        void switchGlobalToolTo(UIToolType enmType);
+        /** Switches Machine tool to passed @a enmType. */
+        void switchMachineToolTo(UIToolType enmType);
         /** Closes Global tool of passed @a enmType. */
         void closeGlobalTool(UIToolType enmType);
@@ -324,8 +324,10 @@
         void sltHandleToolMenuRequested(const QPoint &position, UIVirtualMachineItem *pItem);
 
-        /** Handles signal about global Tools-pane index change. */
-        void sltHandleGlobalToolsPaneIndexChange();
-        /** Handles signal about machine Tools-pane index change. */
-        void sltHandleMachineToolsPaneIndexChange();
+        /** Handles signal about global Tools-menu index change.
+          * @param  enmType  Brings current tool type. */
+        void sltHandleGlobalToolsMenuIndexChange(UIToolType enmType) { switchGlobalToolTo(enmType); }
+        /** Handles signal about machine Tools-menu index change.
+          * @param  enmType  Brings current tool type. */
+        void sltHandleMachineToolsMenuIndexChange(UIToolType enmType) { switchMachineToolTo(enmType); }
 
         /** Handles signal requesting switch to Activity pane of machine with @a uMachineId. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h	(revision 102812)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h	(revision 102813)
@@ -55,6 +55,7 @@
     /** @name General stuff.
       * @{ */
-        /** Notifies listeners about selection changed. */
-        void sigSelectionChanged();
+        /** Notifies listeners about selection changed.
+          * @param  enmType  Brings current tool type. */
+        void sigSelectionChanged(UIToolType enmType);
 
         /** Notifies listeners about expanding started. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 102812)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 102813)
@@ -219,5 +219,5 @@
 
     /* Notify about selection change: */
-    emit sigSelectionChanged();
+    emit sigSelectionChanged(toolsType());
 
     /* Move focus to current-item: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h	(revision 102812)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h	(revision 102813)
@@ -72,6 +72,7 @@
     /** @name Selection stuff.
       * @{ */
-        /** Notifies about selection changed. */
-        void sigSelectionChanged();
+        /** Notifies about selection changed.
+          * @param  enmType  Brings current tool type. */
+        void sigSelectionChanged(UIToolType enmType);
         /** Notifies about focus changed. */
         void sigFocusChanged();